--[[
Copyright (C) 2016  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

if(buildingplatformtweaks.config.oilBarrelingBuilding) then

	--take care of oil barrel coming from mod that ovveride vanilla ones, if they exist we edit them instead of vanilla barrel
	local fillOilBarrelRecipeName
	if(data.raw.recipe["bob-fill-crude-oil-barrel"]) then
		fillOilBarrelRecipeName = "bob-fill-crude-oil-barrel"
	else
		fillOilBarrelRecipeName = "fill-crude-oil-barrel"
	end
	local emptyOilBarrelRecipeName
	if(data.raw.recipe["bob-empty-crude-oil-barrel"]) then
		emptyOilBarrelRecipeName = "bob-empty-crude-oil-barrel"
	else
		emptyOilBarrelRecipeName = "empty-crude-oil-barrel"
	end
	

	local bpCategoryName = "bp-oil-barreling"

	data:extend({

		{
			type = "recipe-category",
			name = bpCategoryName
		},
		{
			type = "item",
			name = "bp-oil-barreling-machine",
			icon = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/oil-barreling-machine.png",
			flags = {"goes-to-quickbar"},
			subgroup = "production-machine",
			order = "b[oil-barreling-machine]",
			place_result = "bp-oil-barreling-machine",
			stack_size = 50
		},
		{
			type = "assembling-machine",
			name = "bp-oil-barreling-machine",
			icon = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/oil-barreling-machine.png",
			flags = {"placeable-neutral", "placeable-player", "player-creation"},
			minable = {hardness = 0.2, mining_time = 0.5, result = "bp-oil-barreling-machine"},
			max_health = 200,
			corpse = "medium-remnants",
			collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
			selection_box = {{-1, -1}, {1, 1}},
			dying_explosion = "medium-explosion",
			resistances =
			{
			  {
				type = "fire",
				percent = 70
			  }
			},
			fluid_boxes =
			{
			  {
				production_type = "input",
				pipe_picture = 
				{
					north =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-north.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {0.09375, 0.4375}
					},
					east =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-east.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {-0.71875, 0}
					},
					south =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-south.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {0.0625, -1}
					},
					west =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-west.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {0.78125, 0.03125}
					}
				},
				pipe_covers =  {
					north =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-north.png",
					  priority = "extra-high",
					  width = 44,
					  height = 32
					},
					east =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-east.png",
					  priority = "extra-high",
					  width = 32,
					  height = 32
					},
					south =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-south.png",
					  priority = "extra-high",
					  width = 46,
					  height = 52
					},
					west =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-west.png",
					  priority = "extra-high",
					  width = 32,
					  height = 32
					}
				},
				base_area = 5,
				base_level = -1,
				pipe_connections = {{ type="input", position = {0.5, -1.5} }}
			  },
			  {
				production_type = "output",
				pipe_picture = 
				{
					north =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-north.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {0.09375, 0.4375}
					},
					east =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-east.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {-0.71875, 0}
					},
					south =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-south.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {0.0625, -1}
					},
					west =
					{
					  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/pipe-west.png",
					  priority = "extra-high",
					  width = 41,
					  height = 40,
					  shift = {0.78125, 0.03125}
					}
				},
				pipe_covers =  {
					north =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-north.png",
					  priority = "extra-high",
					  width = 44,
					  height = 32
					},
					east =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-east.png",
					  priority = "extra-high",
					  width = 32,
					  height = 32
					},
					south =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-south.png",
					  priority = "extra-high",
					  width = 46,
					  height = 52
					},
					west =
					{
					  filename = "__base__/graphics/entity/pipe-covers/pipe-cover-west.png",
					  priority = "extra-high",
					  width = 32,
					  height = 32
					}
				},
				base_area = 5,
				base_level = 1,
				pipe_connections = {{ type="output", position = {0.5, 1.5} }}
			  },
			  off_when_no_fluid_recipe = true
			},
			fast_replaceable_group = nil,
			animation =
			{
			  filename = buildingplatformtweaks.modRoot.."/graphics/oil_barreling_machine/oil-barreling-machine-2x2.png",
			  priority = "high",
			  width = 80,
			  height = 70,
			  frame_count = 32,
			  line_length = 8,
			  shift = {0.3, -0.06}
			},
			open_sound = { filename = "__base__/sound/machine-open.ogg", volume = 0.85 },
			close_sound = { filename = "__base__/sound/machine-close.ogg", volume = 0.75 },
			vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
			working_sound =
			{
			  sound = {
				{
				  filename = "__base__/sound/assembling-machine-t2-1.ogg",
				  volume = 0.8
				},
				{
				  filename = "__base__/sound/assembling-machine-t2-2.ogg",
				  volume = 0.8
				},
			  },
			  idle_sound = { filename = "__base__/sound/idle1.ogg", volume = 0.6 },
			  apparent_volume = 1.5,
			},
			crafting_categories = {"bp-oil-barreling"},
			crafting_speed = 1,
			energy_source =
			{
			  type = "electric",
			  usage_priority = "secondary-input",
			  emissions = 0.04 / 2.5
			},
			energy_usage = "200kW",
			ingredient_count = 2,
			module_specification =
			{
			  module_slots = 2
			},
			allowed_effects = {"consumption", "speed", "productivity", "pollution"}
		},
		{
			type = "recipe",
			name = buildingplatformtweaks.oilBarrelingRecipeName,
			enabled = false,
			ingredients =
			{
			  {"iron-plate", 10},
			  {"electronic-circuit", 5},
			  {"iron-gear-wheel", 5},
			  {"assembling-machine-2", 1}
			},
			result = "bp-oil-barreling-machine",
			requester_paste_multiplier = 4
		}
	})
	--change category of each recipe to be craftable with the new building.
	local oldCategory = nil
	if(data.raw["recipe"][fillOilBarrelRecipeName]) then
		oldCategory = data.raw["recipe"][fillOilBarrelRecipeName].category
		data.raw["recipe"][fillOilBarrelRecipeName].category = bpCategoryName
	end
	if(data.raw["recipe"][emptyOilBarrelRecipeName]) then
		oldCategory = data.raw["recipe"][emptyOilBarrelRecipeName].category
		data.raw["recipe"][emptyOilBarrelRecipeName].category = bpCategoryName
	end

	--as previous change render recipe uncraftable anywhere else, we need to add our category to all machine that crafted them before
	if(oldCategory) then -- only need to do that if at least one of the recipe exist
		for _,assemblingMachine in pairs(data.raw['assembling-machine']) do
			for _, category in pairs(assemblingMachine.crafting_categories) do
				if category == oldCategory then
					table.insert(assemblingMachine.crafting_categories,bpCategoryName)
					break
				end
			end
		end
	end
	
	--recipe unlock
	if(data.raw['technology'][buildingplatformtweaks.oilBarrelingTechUnlock]) then
		table.insert(data.raw['technology'][buildingplatformtweaks.oilBarrelingTechUnlock].effects,
		{
			type = "unlock-recipe",
			recipe = buildingplatformtweaks.oilBarrelingRecipeName
		})
	else
		data.raw['recipe'][buildingplatformtweaks.oilBarrelingRecipeName].enabled = true 
	end
end